Attribute VB_Name = "Mod1"

'Option Explicit

   ' WARNING: There are three very tricky "gotchas" with this code:
   
    ' 1)    Option Explicit must be commented before compiling.
        '   The Items collection in the ShellFolderView
        '   will cause an error on WinME unless it's enumerated as
        '   "Items" rather than as a strongly typed
        '   FolderItem attained via index. The latter works on Win98 but
        '   not on WinME. On the other hand, using "For all Items in..."
        '   with Items undeclared
        '   works on both systems but won't compile with option explicit. (?!)
        
     ' 2)   If you edit this code, be sure to add all of the
        '   references and also right-click in the object browser
        '   left-side list and select "Show Hidden". Otherwise
        '   many of the objects used here will not show in the
        '   "Intellisense" menu!
          
     '3)   The folder object returns folder items based on view
     '     settings. It is not a good way to enumerate folder
     '     content. For instance, on some systems it may not
     '     list system files (dll, drv, etc.) at all, even if the
     '     setting in Folder options is set to show them! And if
     '     extensions are not showing it may not return those.
     '
          
'-- This module contains everything needed to access an open folder
'-- on any Windows version and return, at minimum, a list of items
'-- and a list of selected items for that folder.

'-- There are 3 different versions of the code here. They are explained
'-- in ModInfo.

'-- References:  ** Select SHOW HIDDEN in right-click of object browser!!!  **
'  oleacc.dll# Accessibility
'  olelib.tlb# Edanmo 's OLE interfaces & functions v1.6
'  Microsoft Internet Controls
'  Microsoft Shell Controls And Automation
'  MSHTML.tlb#Microsoft HTML Object Library

'-- *** REQUIREMENTS ***

'        ABOUT OLELIB.TLB: --------------------------

'-- All of the required references should be already on all
' systems, except for olelib.tlb. Olelib.tlb is a large typelib
'  written by Eduardo Morcillo. Eduardo Morcillo wrote quite a bit
' of interesting VB code over the years, but has apparently dropped
' it for .Net. His website is here:
'    http://www.mvps.org/emorcillo/
'
' But Most of the VB code and pages seem to be gone now. The site itself
' is a mess, a tangle of overused javascript, unnecessary iframes, etc.
' There seems to be very little of anything left there as of this writing.
' But you may still be able to get the typelib from his download links
' page:
'
 '  http://www.mvps.org/emorcillo/download/vb6/
 '  The file you want tl_ole.zip
'
 '
 ' If you can't find a copy of olelib.tlb: I *think* that the only
 ' things that typelib was needed for were IUnknown and QueryInterface.
 ' If you get those from another typelib then olelib.tlb should not
 ' be becessary.

'---------------------------------------------------------------------------


Private Const IID_IShellFolderViewDual As String = "{E7A1AF80-4D96-11CF-960C-0080C7F4EE85}"

'-------- general windows ops ----------------------------------------

Private Const SMTO_ABORTIFHUNG = &H2
Private Declare Function GetClassName Lib "user32.dll" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, lParam As Long) As Long
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, lParam As Any, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
      
 '-- oleacc -------------------------------------
Private Const OBJID_WINDOW = &H0&
Private Const STATE_SELECTED = &H2&
Private Const STATE_FOCUSED = &H4&
Private Const STATE_INVISIBLE = &H8000&
Private Const ROLE_LIST = &H21&
Private Const ROLE_LISTITEM = &H22&

Private Declare Function ObjectFromLresult Lib "oleacc" (ByVal lResult As Long, riid As UUID, ByVal wParam As Long, ppvObject As Any) As Long
Private Declare Function AccessibleObjectFromWindow Lib "oleacc" (ByVal hWnd As Long, ByVal dwId As Long, riid As UUID, ppvObject As Object) As Long
Private Declare Function AccessibleChildren Lib "oleacc" (ByVal paccContainer As IAccessible, ByVal iChildStart As Long, ByVal cChildren As Long, rgvarChildren As Variant, pcObtained As Long) As Long
 
Public Doc1 As IHTMLDocument2  '-- document object of folder window.
Public FolView As WebViewFolderContents  '-- file list control in folder.htt.
Public ObjFolder As shell32.Folder

Private AFils() As String    '-- pre-XP : array of files.
Private AFols() As String    '--pre-XP: array of folders.
Private ASel() As String     '-- array of selected items.
Private AAItems() As String  '-- array of all items.
      
 
Private sFolPath As String   '-- holds path of this folder.
Private SelCnt As Long       '-- number of selected items.
Private ItemCnt As Long, FilCnt As Long, FolCnt As Long
Private BooHaveIEDoc As Boolean  ' pre-XP: Doc object avail.?
Private BooHaveFolderView As Boolean   ' pre-XP: FileList object avail.?
Private BooHaveShellFolder As Boolean
Private BooAA As Boolean   '-- XP: success getting file list.?
      
Private AWins() As Long
Private APaths() As String
Private AWBs() As IWebBrowserApp
Private WinCount As Long
      
Public HCur As Long
Public sClassName As String
Public sFocusName As String '-- name of focussed item.
 
 'called from form.
Public Function GetFolder(sVal As String) As Boolean
  Dim ret As Variant
  Dim i2 As Long, H1 As Long, ISel As Long
  Dim sPath1 As String, s2 As String
  
    '-- return arrays of open Explorer window paths and hWnds using
    '-- the Shell.Windows collection. The Shell Object is in shdoc401.dll
    '-- on Win9x, as part of Active Desktop. On WinXP, Active Desktop
    '-- has been, to a great extent, removed, but the Shell.Object
    '-- functions are still emulated via shell32.dll.
    ret = GetOpenWindows
     If ret = 0 Then Exit Function
    
    ISel = -1
   For i2 = 0 To ret - 1
     If InStr(1, APaths(i2), sVal, 1) > 0 Then
      ISel = i2
       Exit For
     End If
   Next
   
       '-- get folder info. given explorer window handle.
       '-- Init attempts to get the shell folder objects
       '-- and/or info. using three different methods, until
       '-- one of them works.
     If ISel > -1 Then Init ISel

       '-- show msgbox. Should return True, True, True, False on 98 and
       '-- False, True, True, False on XP.
       '-- That is, pre-XP returns Doc, ShellFolderView and Folder.
       '-- XP returns just ShellFolderView and Folder.
       '-- Neither returns true for the Act. Acc. method because the other methods
       '-- succeeded before the Act. Acc. method needed to be used.
       MsgBox "GotDoc: " & BooHaveIEDoc & vbCrLf & "GotList: " & BooHaveFolderView & vbCrLf & "Got Shellfolder: " & BooHaveShellFolder & vbCrLf & "GotAA: " & BooAA

     If ItemCnt > 0 Then
       For i2 = 0 To ItemCnt - 1
         s2 = s2 & AAItems(i2) & vbCrLf
       Next
     End If
     
       MsgBox "Item Count: " & ItemCnt & vbCrLf & s2

     s2 = ""
       If SelCnt > 0 Then
         For i2 = 0 To SelCnt - 1
           s2 = s2 & ASel(i2) & vbCrLf
         Next
           MsgBox "SelCount: " & SelCnt & vbCrLf & s2
       End If

       MsgBox "Focussed item is: " & sFocusName
    GetFolder = True
End Function

  '-- Use Shell.Windows to get all open explorer windows hWnd and path.
  '-- See ModInfo for explanation.
  '-- According to the docs, a Windows collection item is an IE instance,
  '-- but that's not really true. On Win9x it's the parent window
  '-- of an IE instance. Most of the IE properties are not available.
  '-- On XP, Web View is Web View in name only. There is no sub IE-class
  '-- window in the window hierarchy of an explorer window.
  
  '-- The method here that filters out IE instances checks for
  '-- the existence of a folder matching the returned path or "LocationURL".
  '   (Shell.Windows converts the folder path to URL to make it "webby"!)
  '   Another method would be to use the hWnd to check the class name.
  '   IE returns "IEFrame"....but not sure if that's true on all systems.
  '  A folder returns "ExplorerWClass" on 2000 and "CabinetWClass" on Win9x/XP.
Public Function GetOpenWindows() As Variant
  Dim SHP As Shell
  Dim Wins As Object
  Dim ie1 As IWebBrowserApp
  Dim SV As ShellFolderView
  Dim i2 As Long, i3 As Long
  Dim sPath1 As String
       Err.Clear
    ' On Error Resume Next
      ClearVars
      GetOpenWindows = CVar(0)
    Set SHP = New Shell
    Set Wins = SHP.Windows
      If Wins.Count = 0 Then
        Set Wins = Nothing
        Set SHP = Nothing
        Exit Function
      End If
      
    i3 = Wins.Count - 1
    ReDim AWins(i3) As Long
    ReDim APaths(i3) As String
    ReDim AWBs(i3) As IWebBrowserApp
    
    i2 = 0
      For Each ie1 In Wins
        sPath1 = ie1.LocationURL
        CleanPath sPath1
         If (FolderExists(sPath1) = True) Then
              '-- This approach of storing the window object references can crash
              '-- Explorer if the last window is closed while the program is running.
              '-- It doesn't seem to be a problem otherwise, but that's problem enough!
              '-- This approach was left here for simplicity because this is demo code.
              '-- In actual usage another iteration of the Shell.Windows collection
              '-- should be done to find the desired IE instance, rather than storing
              '-- all of the IE object references.
              '-- The IE object is needed for the second method of returning folder
              '-- objects and data. While the Shell.Windows IE object seems to be
              '   a dummy wrapper of some kind - and its document is a dummy doc
              '-- without properties - it's nevertheless tied in such that its document
              '-- object can return a
              '   ShellFolderView through a QueryInterface call.
            Set AWBs(i2) = ie1
            
              '-- store the hWnd and path for all open folder windows.
            AWins(i2) = ie1.hWnd
            APaths(i2) = sPath1
            i2 = i2 + 1
         End If
      Next
      
    Set ie1 = Nothing
    Set Wins = Nothing
    Set SHP = Nothing
      
        '-- eliminate array elements empty because of IE instances.
      If ((i2 - 1) < i3) And (i2 > 0) Then
        ReDim Preserve AWins(i2 - 1) As Long
        ReDim Preserve APaths(i2 - 1) As String
        ReDim Preserve AWBs(i2 - 1) As IWebBrowserApp
      End If
      WinCount = i2
      GetOpenWindows = CVar(WinCount)
    
End Function

Public Sub Init(iDex As Long)  'ByVal H1 As Long, sPathIn As String)
  Dim Boo1 As Boolean
  Dim LRet As Long, HOut As Long
  Dim Unk As OLELIB.IUnknown
  Dim CID As UUID
  Dim Doc2 As Object
  
  sFolPath = APaths(iDex)
  HOut = AWins(iDex)
  Set Doc1 = GetIEDoc(HOut, Boo1)
   BooHaveIEDoc = Boo1
     If BooHaveIEDoc = True Then
         BooHaveFolderView = Get9xFileList
         If (BooHaveFolderView = True) Then Exit Sub
     End If
'-- if BooHaveFolderView = true then all set.
'-- If not then try the QueryInterface approach.
        
   Set Doc1 = Nothing
   BooHaveIEDoc = False
   
   '-- This approach can crash Explorer. See above in GetOpenWindows.
   Set Doc2 = AWBs(iDex).Document
   Set Unk = Doc2
    CLSIDFromString IID_IShellFolderViewDual, CID
     LRet = Unk.QueryInterface(CID, FolView)
       If (LRet = 0) Then
          BooHaveFolderView = GetXPFileList
       End If
   Set Unk = Nothing
   Set Doc2 = Nothing
     If (BooHaveFolderView = True) Then Exit Sub
         
'-- Two misses if it's still going. Have to go the XP/Act.Acc. way.
    HOut = H1
    LRet = GetXPListViaAA(HOut)
    If LRet = 0 Then
      BooAA = True
    Else
      BooAA = False
      MsgBox "3rd way failed. Error was " & CStr(LRet)
    End If
End Sub

Public Sub ClearVars()
  Dim i7 As Long, iUB As Long
    On Error Resume Next
  Erase AWins
  Erase APaths
  
  Err.Clear
  On Error Resume Next
    iUB = UBound(AWBs)
      If Err.Number = 0 Then
        For i7 = 0 To iUB
          Set AWBs(i7) = Nothing
        Next
      End If
      
  Erase AWBs
  sFocusName = ""
  WinCount = 0
  ItemCnt = 0
  SelCnt = 0
End Sub

'--============= Pre-XP ================================
  
   '-- Get document object from hWnd of open window.
   '-- This only works if there's a sub window of class "Internet Explorer_Server"
Private Function GetIEDoc(ByVal H1 As Long, Success As Boolean) As IHTMLDocument
  Dim IID_IHTMLDocument2 As UUID
  Dim LMsg As Long, LRes As Long, LRet As Long, H2 As Long
       Success = False
         H2 = GetIEWindow(H1)
           If (H2 = 0) Then Exit Function
  
  LMsg = RegisterWindowMessage("WM_HTML_GETOBJECT")
  LRet = SendMessageTimeout(H2, LMsg, 0, 0, SMTO_ABORTIFHUNG, 1000, LRes)
            If LRes = 0 Then Exit Function
         
      With IID_IHTMLDocument2
         .Data1 = &H332C4425
         .Data2 = &H26CB
         .Data3 = &H11D0
         .Data4(0) = &HB4
         .Data4(1) = &H83
         .Data4(2) = &H0
         .Data4(3) = &HC0
         .Data4(4) = &H4F
         .Data4(5) = &HD9
         .Data4(6) = &H1
         .Data4(7) = &H19
      End With
             
      LRet = ObjectFromLresult(LRes, IID_IHTMLDocument2, 0, GetIEDoc)
     If LRet = 0 Then Success = True
End Function

Private Function Get9xFileList() As Boolean

     Get9xFileList = False
         If Doc1 Is Nothing Then Exit Function
     Set FolView = Doc1.All.Item("FileList")
         If FolView Is Nothing Then Exit Function
      
     EnumFileList
     Get9xFileList = True
End Function

 '-- called by both 9x and XP functions.
Private Sub EnumFileList()
  Dim LRet As Long, i2 As Long, iFils As Long, iFols As Long
  Dim FIs As shell32.FolderItems
  Dim s2 As String
  
 sFocusName = FolView.FocusedItem.Name  '-- name of focussed item.
      
      Set FIs = FolView.SelectedItems
      SelCnt = FIs.Count
        If (SelCnt > 0) Then
             ReDim ASel(SelCnt - 1)
             i2 = 0
           For Each Item In FIs
               ASel(i2) = Item.Name  '-- store list of sel. items.
               i2 = i2 + 1
           Next
        End If
      Set FIs = Nothing
      Set ObjFolder = FolView.Folder
       
   '-- ****NOTE**** This code should stop here and use API
   '-- for enumerating folder content. The ShellFolderView
   '-- used above was necessary to get selected objects, but
   '-- the Folder object is not really necessary. Better to
   '-- use FindFirstFile, FindNextFile, etc. Especially given
   '-- that a WIN32_FIND_DATA structure returns pretty much
   '-- everything of relevance that one might return from a
   '-- Folder.FolderItems.Item.
   
   '-- The code below here uses a Shell Folder object, retrieved
   '-- from the ShellFolderView.Folder property, to enumerate
   '-- folder content as a FolderItems collection. But the Folder
   '-- object is buggy. On a
   '-- test with XP it did not "see" hidden files. On a test
   '-- with Win98, wherein all file types were visible in Explorer,
   '-- it did not see hidden files or files with the extensions
   '-- .DLL and .DRV!!
   
   '-- The Folder object is designed to reflect the visual content
   '-- of a folder - rather than seeing the folder in terms of file system -
   '-- and it doesn't even do a very good job at what it's supposed
   '-- to achieve.
   
       If Not (ObjFolder Is Nothing) Then
           BooHaveShellFolder = True
         ItemCnt = ObjFolder.Items.Count
           iFils = 0
           iFols = 0
          If (ItemCnt > 0) Then
              ReDim AAItems(0 To ItemCnt - 1)
              i2 = 0
            Set FIs = ObjFolder.Items
             For Each Item In FIs
                s2 = Item.Name
                  AAItems(i2) = s2  '-- store list of items.
                If Item.IsFolder Then
                   ReDim Preserve AFols(iFols) As String
                   AFols(iFols) = s2  '-- store list of folders.
                   iFols = iFols + 1
                Else
                   ReDim Preserve AFils(iFils) As String
                   AFils(iFils) = s2 '-- store list of files.
                   iFils = iFils + 1
                End If
                 i2 = i2 + 1
              Next
             Set FIs = Nothing
          FilCnt = iFils
          FolCnt = iFols
         End If
       End If
  End Sub
  
'-- ==================== WinXP ==============================

Private Function GetXPFileList() As Boolean
  GetXPFileList = False
    If FolView Is Nothing Then Exit Function
    EnumFileList
    GetXPFileList = True
End Function

Private Function GetXPListViaAA(ByVal H1 As Long) As Long
  Dim HList As Long, AccRet As Long
  Dim Boo2 As Boolean
      GetXPListViaAA = -6  ' didn't get listview window handle.
    HList = GetListViewWindow(H1)
      If HList = 0 Then Exit Function '--failed to get listview hWnd.
       
    AccRet = GetXPAcc(HList)
    GetXPListViaAA = AccRet
       
End Function

 '-- get information about folder items via Active Accessibility
 '-- if both methods for returning the ShellfolderView failed.
Private Function GetXPAcc(ByVal H1 As Long) As Long
  Dim LRet As Long, CNum As Long, LStart As Long, LNumRet As Long, LState As Long
  Dim i2 As Long, ISel As Long, iActual As Long
  Dim Ob1 As IAccessible, Ob2 As IAccessible, Ob3 As IAccessible
  Dim Boo1 As Boolean
  Dim sName As String
  Dim AV() As Variant
  Dim AccID As UUID
  
     GetXPAcc = -1
    With AccID   '-- iaccessible.
      .Data1 = &H618736E0
      .Data2 = &H3C3D
      .Data3 = &H11CF
      .Data4(0) = &H81
      .Data4(1) = &HC
      .Data4(2) = &H0
      .Data4(3) = &HAA
      .Data4(4) = &H0
      .Data4(5) = &H38
      .Data4(6) = &H9B
      .Data4(7) = &H71
    End With
      
   LRet = AccessibleObjectFromWindow(ByVal H1, OBJID_WINDOW, AccID, Ob1)
       If (LRet <> 0) Then Exit Function
       
    GetXPAcc = -2
  CNum = Ob1.accChildCount
      If (CNum = 0) Then GoTo EndOps
      
    GetXPAcc = -3
  Boo1 = GetSubListObject(Ob1, CNum, Ob2)
     If Boo1 = False Then GoTo EndOps
     
   CNum = Ob2.accChildCount
    LStart = 0
    LNumRet = 0
    ReDim AV(0 To CNum - 1) As Variant
           '-- now get the IAccessible objects for the window children:
           GetXPAcc = -4
    LRet = AccessibleChildren(Ob2, LStart, CNum, AV(0), LNumRet)
      If (LRet <> 0) Or (LNumRet = 0) Then GoTo EndOps
      
       ReDim AAItems(0 To LNumRet - 1) As String
       ISel = 0
       iActual = 0 '-- not all members are necessarily valid files/folders.
     For i2 = 0 To (LNumRet - 1)
        If Not IsObject(AV(i2)) Then
          sName = Ob2.accName(AV(i2))
          LState = Ob2.accState(AV(i2))
          
            If (Len(sName) > 0) And ((LState And STATE_INVISIBLE) <> STATE_INVISIBLE) Then
              AAItems(iActual) = sName '-- add item name to array.
              iActual = iActual + 1
                If (LState And STATE_SELECTED) = STATE_SELECTED Then
                   ReDim Preserve ASel(0 To ISel) As String
                   ASel(ISel) = sName
                   ISel = ISel + 1
                End If
                If ((LState And STATE_FOCUSED) = STATE_FOCUSED) Then
                  sFocusName = sName
                End If
            End If
            
        End If
     Next
      
      GetXPAcc = 0
      ItemCnt = iActual
      SelCnt = ISel
EndOps:
        Set Ob2 = Nothing
        Set Ob1 = Nothing
       
End Function

  '-- Get listview child of SysListView32 window that has list items.
  '-- This returns the list iAccessible object to GetXPAcc, which
  '-- then goes down to the next level to get the file/folder elements.
Private Function GetSubListObject(Ob As IAccessible, ByVal LNum As Long, ObRet As IAccessible) As Boolean
 Dim LRet As Long, LNumRet As Long, LState As Long
 Dim LStart As Long, i As Long, LRole As Long
 Dim Ob4 As IAccessible
 Dim AV() As Variant

     'On Error Resume Next
   GetSubListObject = False
  LStart = 0
  LNumRet = 0
   ReDim AV(0 To LNum - 1) As Variant
   LRet = AccessibleChildren(Ob, LStart, LNum, AV(0), LNumRet)
     If (LRet = 0) And (LNumRet > 0) Then
        For i = 0 To (LNumRet - 1)
           If IsObject(AV(i)) Then
              Set Ob4 = AV(i)
              LRole = CLng(Ob4.accRole)
              If (LRole = 33) Then  'role_list
                 Set ObRet = Ob4
                 Exit For
              End If
           Else
                LRole = CLng(Ob.accRole(AV(i)))
                If (LRole = 33) Then
                  Set ObRet = Ob
                  Exit For
                End If
           End If
        Next
         Set Ob4 = Nothing
         If IsObject(ObRet) Then GetSubListObject = True
     End If
End Function


 '-- return handle for ListView window in folder.
 Private Function GetListViewWindow(ByVal H1 As Long) As Long
   Dim LRet As Long
       '---- if this code runs then methods #1 and #2 failed.
    HCur = 0
    GetListViewWindow = 0
    sClassName = "SysListView" 'SysListView32
    LRet = EnumChildWindows(H1, AddressOf EnumChildProc, 0)
      GetListViewWindow = HCur  '-- either 0 or handle of listview window.
 End Function
 
   '-- return handle for actual IE browser window under IE running instance or folder, in order to get Doc.
 Private Function GetIEWindow(ByVal H1 As Long) As Long
   Dim LRet As Long
    HCur = 0
    GetIEWindow = 0
    sClassName = "Explorer_Server" ' "Internet Explorer_Server"
    LRet = EnumChildWindows(H1, AddressOf EnumChildProc, 0)
      GetIEWindow = HCur  '-- either 0 or handle of browser.
 End Function
 
  '-- The actual folder window hierarchy in 9x/2000 vs XP
  '-- (by window class name)is listed here.
  '-- Since EnumChildWindows is really "EnumALLWindowsUnderThisOne,
  '-- it's only necessary to look for the SysListView32 window when
  '-- using the Act. Acc. method (#3) of enumerating folder contents.
  
  '   On Win9x the very top window, returned by Shell.Windows, is
  '  "CabinetWClass". On Win2000 it's "ExplorerWClass". But that
  '  doesn't really matter because 9x/2000 are the same from there down:
  
'--------------------------------------------------------
  '-- Window hierarchy 9x/2000 with Web View active:
  
   ' Top window  ("CabinetWClass" or "ExplorerWClass")
   ' -- SHELLDLL_DefView
   '   -- Internet Explorer_Server  ' IE browser window, from whence a Document object is available.
   '      -- ATL Shell Embedding
   '         -- SysListView32  ' ListView that shows files/folders.

'---------------------------------------------------------

   '-- Window hierarchy XP:
   
    ' Top window  ("CabinetWClass")
    ' -- SHELLDLL_DefView
    '    -- DUIViewWndClassName
    '       -- DirectUIHWND
    '          -- CtrlNotifySink
    '             -- SysListView32  ' ListView that shows files/folders.
'----------------------------------------------------------------

  '-- callback for function above.
Public Function EnumChildProc(ByVal hWnd As Long, lParam As Long) As Long
   Dim s2 As String
     s2 = GetWinClass(hWnd)
    If InStr(1, s2, sClassName, 1) > 0 Then
      HCur = hWnd
      EnumChildProc = 0
    Else
      EnumChildProc = 1
    End If
End Function

  '-- get the class name for a window, given the hWnd.
Public Function GetWinClass(ByVal H1 As Long) As String
  Dim sBuf As String
  Dim LRet As Long
     On Error Resume Next
       GetWinClass = ""
    sBuf = String$(256, 0)
    LRet = GetClassName(H1, sBuf, Len(sBuf))
     If (LRet > 0) Then GetWinClass = Left$(sBuf, LRet)
End Function

  ' Shell.Windows returns a "URL" which must then be fixed.
Private Sub CleanPath(ByRef sPathIn As String)
  Dim Pt1 As Long
    sPathIn = Replace(sPathIn, "/", "\")
    sPathIn = Replace(sPathIn, "%20", " ")  '-- fix spaces.
    Pt1 = InStrRev(sPathIn, ":")
    If Pt1 > 2 Then sPathIn = Right$(sPathIn, (Len(sPathIn) - (Pt1 - 2))) '-- clip "file///"
End Sub

Private Function FolderExists(ByVal sPath As String) As Boolean
  On Error Resume Next
    FolderExists = (GetAttr(sPath) And vbDirectory) = vbDirectory
    Err.Clear
End Function
